Program Eprommer;
Uses CRT, DOS;
Const BA = $378;             {LPT1}
Var n: Word;
    Ch : Char;
    Dateiname : String;
    Typ256 : Boolean;
procedure Setzen (Port_Nr,Wert: Byte);
var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;             {D1=CS1=0}
  If (Port_Nr div 4)=1 then CS := 2;             {D2=CS2=0}
  Port [BA] := CS + 1;                           {D0=St=1}
  Port [BA+2] := ((Port_Nr AND 3) + 4) XOR 11;   {stuurcommando}
  Port [BA] := CS;                               {D0=St=0}
  Port [BA+2] := Wert XOR 11;                    {datawoord}
  Port [BA] := CS + 1;                           {D0=St=1}
  Port [BA] := 6 + 1;                            {CS1=1, CS2=1}
end;
function Lesen (Port_Nr : Byte) : Byte;
var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;             {D1=CS1=0}
  If (Port_Nr div 4)=1 then CS := 2;             {D2=CS2=0}
  Port [BA] := CS + 1;                           {D0=St=1}
  Port [BA+2] := (Port_Nr AND 3) XOR 11;         {stuurcommando}
  Port [BA] := CS;                               {D0=St=0}
  Port [BA+2] := 15 XOR 11;                      {bus hoogohmig}
  Lesen := Port[BA+2] AND 15 XOR 11;             {data lezen}
  Port [BA] := CS + 1;                           {D0=St=1}
  Port [BA] := 6 + 1;                            {CS1=1, CS2=1}
end;
procedure AND_Port (Port_Nr,Wert: Byte);
var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;             {D1=CS1=0}
  If (Port_Nr div 4)=1 then CS := 2;             {D2=CS2=0}
  Port [BA] := CS + 1;                           {D0=St=1}
  Port [BA+2] := ((Port_Nr AND 3) + 12) XOR 11;  {stuurcommando}
  Port [BA] := CS;                               {D0=St=0}
  Port [BA+2] := Wert XOR 11;                    {datawoord}
  Port [BA] := CS + 1;                           {D0=St=1}
  Port [BA] := 6 + 1;                            {CS1=1, CS2=1}
end;
procedure OR_PORT (Port_Nr,Wert: Byte);
var CS : Byte;
begin
  If (Port_Nr div 4)=0 then CS := 4;             {D1=CS1=0}
  If (Port_Nr div 4)=1 then CS := 2;             {D2=CS2=0}
  Port [BA] := CS + 1;                           {D0=St=1}
  Port [Ba+2] := ((Port_Nr AND 3) + 8) XOR 11;   {stuurcommando}
  Port [BA] := CS;                               {D0=St=0}
  Port [BA+2] := Wert XOR 11;                    {datawoord}
  Port [BA] := CS + 1;                           {D0=St=1}
  Port [BA] := 6 + 1;                            {CS1=1, CS2=1}
end;
procedure DatenSetzen (Wert: Byte);
begin
  Setzen (0, Wert mod 16);                       {P0: D0..D3}
  Setzen (1, Wert div 16);                       {P1: D4..D7}
end;
function Datenlesen: Byte;
begin
  Datenlesen := Lesen (0) + 16 * Lesen (1);      {tweemaal}
  Datenlesen := Lesen (0) + 16 * Lesen (1);      {P0, P1 lezen}
end;
procedure AdresseSetzen (Adresse: Word);
begin
  Setzen (2, Lo (Adresse) mod 16);               {P2: A0...A3}
  Setzen (3, Lo (Adresse) div 16);               {P3: A4...A7}
  Setzen (4, Hi (Adresse) mod 16);               {P4: A8...A11}
  Setzen (5, Hi (Adresse) div 16);               {P5: A12...A13}
  If Typ256 then begin
    if Adresse < 16384 then AND_Port (6,11)      {P62=A14=0}
    else OR_Port (6,4);                          {P62=A14=1}
  end;
end;
function Auslesen (Adresse: Word) : Byte;
begin
  Setzen (6,4);                                  {/CE=0, /OE=0}
  AdresseSetzen (Adresse);
  Auslesen := Datenlesen;
end;
procedure Brennen (Adresse: Word; Wert: Byte);
begin
  AdresseSetzen (Adresse);
  DatenSetzen (Wert);
  If Typ256 then begin
    Or_Port (6,11);                             {/OE=1, Vpp aan}
    AND_Port (6,14);                            {CE=0}
  end else Setzen (6,10);                       {Vpp, /OE=1, /PGM=0}
  delay (25);                                   {1ms branden}
  Setzen (6,7);                                 {Upp uit, /CE=1, ?PGM=1}
end;
procedure BrennenUndPruefen (Adresse: Word; Wert: Byte);
var n, m: Integer;
begin
  n:=0;
  repeat
    Brennen (Adresse, Wert);
    n := n + 1;                                 {n * 1ms}
  until (Wert >= Auslesen (Adresse)) or (n=50);
  for m := 1 to 3*n do Brennen (Adresse, Wert); {3*n ms}
end;
procedure Auslesen_Datei;
var f :file of byte;
    r, wert : Byte;
    Adresse, Anzahl, n : Word;
begin
  Writeln ('startadres');
  readln (Adresse);
  writeln ('aantal bytes');
  readln (Anzahl);
  writeln ('naam bestand');
  readln (Dateiname);
  Assign(f,dateiname);
  {$I-} Rewrite (f); {SI+}
  r:=IOResult;
  If r = 0 then begin
    for n:= Adresse to (Adresse+Anzahl-1) do begin
      Wert := Auslesen (n);
      write (Wert, ' ');
      write (f,Wert);
    end;
    Close(f);
    end;
  writeln;
  writeln ('uitlezen geslaagd!');
  writeln;writeln;
end;
procedure Vergleichen;
var f :file of byte;
    r,wert, wert2 : Byte;
    Adresse, n : Integer;
    Fehler : boolean;
begin
  Fehler := false;
  Writeln ('startadres');
  readln (Adresse);
  writeln ('naam bestand');
  readln (Dateiname);
  Assign(f,dateiname);
  {$I-} Reset (f); {$I+}
  r:=IOResult;
  if r = 0 then begin
    for n := 1 to filesize (f) do begin
      wert := Auslesen (Adresse+n-1);
      write (wert, ' ');
      read (f,wert2);
      if wert <> wert2 then Fehler := true;
    end;
    Close (f);
  end;
  writeln;
  if Fehler then writeln ('fout gevonden')
    else writeln ('programmering geslaagd!');
  repeat until Keypressed;
end;
procedure Programmieren;
var f: file of byte;
   code: Char;
   r, wert: Byte;
   Adresse, n: Word;
begin
  Writeln ('startadres');
  readln (Adresse);
  writeln ('naam bestand');
  readln (Dateiname);
  Assign (f,dateiname);
  {$I-} Reset (f); {$I+}
  r:=IOResult;
  IF r = 0 then begin
    for n:= 1 to filesize (f) do begin
      Read(f,wert);
      BrennenUndPruefen (Adresse+n-1,Wert);
      write (Wert, ' ');
    end;
    Close (f);
  end;
  writeln; writeln;
end;
begin
  Typ256 := false;
  Setzen (6,7);                                 {EPROM niet aktief}
  If ParamStr (1) = '2' then Typ256 := true;
  repeat
    clrscr;
    if Typ256 then writeln ('EPROM type 27256')
      else writeln ('EPROM type 2764/27128');
    writeln ('<S>chrijven <L>ezen <V>ergelijken <Q>uit');
    readln (ch);
    Ch := upcase (Ch);
    if ch = 'S' then programmieren;
    if Ch = 'V' then vergleichen;
    if Ch = 'L' then Auslesen_Datei;
  until Ch = 'Q';
end.
